<link rel="import" href="/bower_components/polymer/polymer-element.html">

<link rel="import" href="/bower_components/paper-styles/color.html">
<link rel="import" href="../l1page-theme/l1page-theme.html">

<link rel="import" href="/bower_components/app-layout/app-drawer-layout/app-drawer-layout.html">
<link rel="import" href="/bower_components/app-layout/app-header/app-header.html">
<link rel="import" href="/bower_components/app-layout/app-toolbar/app-toolbar.html">
<link rel="import" href="/bower_components/app-layout/app-drawer/app-drawer.html">
<link rel="import" href="/bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="/bower_components/paper-item/paper-icon-item.html">
<link rel="import" href="/bower_components/iron-pages/iron-pages.html">
<link rel="import" href="/bower_components/iron-icons/iron-icons.html">
<link rel="import" href="/bower_components/iron-icons/communication-icons.html">
<link rel="import" href="/bower_components/iron-icons/editor-icons.html">
<link rel="import" href="/bower_components/iron-icons/image-icons.html">
<link rel="import" href="/bower_components/iron-icons/notification-icons.html">
<!-- <link rel="import" href="/bower_components/paper-progress/paper-progress.html"> -->
<link rel="import" href="/bower_components/nebula-dispatch/nebula-dispatch.html">
<link rel="import" href="/bower_components/relative-time/relative-time.html">

<link rel="import" href="/bower_components/paper-checkbox/paper-checkbox.html">

<link rel="import" href="/bower_components/paper-fab/paper-fab.html">
<link rel="import" href="/bower_components/paper-dialog/paper-dialog.html">
<link rel="import" href="/bower_components/paper-tooltip/paper-tooltip.html">

<link rel="import" href="/bower_components/app-route/app-location.html">
<link rel="import" href="/bower_components/app-route/app-route.html">

<link rel="import" href="../l1-home/l1-home.html">
<link rel="import" href="../l1page-api/l1page-api.html">
<link rel="import" href="../l1page-drawer-links/l1page-drawer-links.html">
<link rel="import" href="../l1-trigger-diagram/l1-trigger-diagram.html">
<link rel="import" href="../l1page-log-list/l1page-log-list.html">
<link rel="import" href="../process-controller/process-controller.html">
<link rel="import" href="../subsystem-details/subsystem-details.html">
<link rel="import" href="../trigger-rates/trigger-rates.html">
<link rel="import" href="../toast-manager/toast-manager.html">
<link rel="import" href="../shifter-info/shifter-info.html">
<link rel="import" href="../suggestion-list/suggestion-list.html">

<link rel="import" href="../authentication-manager/authentication-manager.html">

<link rel="import" href="big-status-icon.html">
<link rel="import" href="../subsystem-keys/subsystem-keys.html">

<!--
`<l1-page>` is the main element of the Level-1 Page
-->

<dom-module id=l1-page>
  <template>
    <link rel=stylesheet href="l1-page.css?__inline=true">
    <style include=l1page-theme></style>

    <app-location route={{route}}></app-location>
    <app-route route={{route}} pattern="/:activeWidget" data={{urlData}} tail={{urlDataTail}}></app-route>
    <app-route route={{urlDataTail}} pattern="/:page" data={{subUrlData}}></app-route>

    <l1page-api url=/api/v0/run data={{runData}} auto></l1page-api>
    <l1page-api url=/api/v0/subsystems data={{subsystemData}} auto></l1page-api>

    <app-toolbar id="toolbar">
      <section top-item>

        <div class="navItem" role="listbox" >
          <paper-icon-item toggle-view on-click="toggleDrawer">
            <iron-icon icon="menu" slot="item-icon"></iron-icon>
            <span toggle-view hide-for-small>Links</span>
          </paper-icon-item>
          <paper-icon-item toggle-view on-click="openWidgetCall">
            <iron-icon icon="communication:call" slot="item-icon"></iron-icon>
            <span toggle-view hide-for-small>Contacts</span>
          </paper-icon-item>
          <a style="text-decoration:none;" href="https://its.cern.ch/jira/projects/CMSLITOLSW/" target="_blank">
            <paper-icon-item toggle-view>
              <iron-icon icon="bug-report" slot="item-icon"></iron-icon>
              <span toggle-view hide-for-small>Requests</span>
            </paper-icon-item>
          </a>
          <paper-icon-item toggle-view on-click="gotoRates" selected$="[[isRateView]]">
            <iron-icon icon="trending-up" slot="item-icon" on-click="gotoRates"></iron-icon>
            <span toggle-view hide-for-small selected$="[[isRateView]]">Rates</span>
          </paper-icon-item>
          <paper-icon-item toggle-view on-click="gotoMain" selected$="[[isMainView]]">
            <iron-icon icon="home" slot="item-icon"></iron-icon>
            <span toggle-view hide-for-small selected$="[[isMainView]]">Home</span>
          </paper-icon-item>
        </div>

        <div class="connection">
          <p hide$=[[!apiConnected]]>
            <span hide-for-small>connected to API</span>
            <iron-icon slow-rotation icon="notification:sync"></iron-icon>
          </p>
          <p hide$=[[apiConnected]] error>
            <span hide-for-small>connection with API lost</span>
            <iron-icon icon="notification:sync-problem"></iron-icon>
          </p>
          <paper-icon-button icon=[[themeIcon]] on-click=_toggleThemeMode title="toggle day/night mode"></paper-icon-button>
          <dom-if if=[[isLoggedIn]]>
            <template>
              <p>[[userInfo.first_name]]</p>
              <paper-icon-button icon=power-settings-new on-click=logout title="sign out"></paper-icon-button>
            </template>
          </dom-if>
        </div>
      </section>

      <section left banner second-row>
        <div horizontal left>
          <div flexitem hide$="[[!_hasPrescale(runData.trgMoni)]]"> 
            <p title align="right">Prescale</p>
            <p align="right">[[runData.trgMoni.PRESCALE_NAME]] ([[runData.trgMoni.PRESCALE_INDEX]])</p>
          </div>
          <div show-hand flexitem on-click="openWidgetTrigger">
            <p title align="right">Current key</p>
            <p show-hand id="config_info" align="right">[[runData.trgConf.L1_HLT_MODE]]/v[[runData.trgConf.L1_HLT_VERSION]]</p>
            <paper-tooltip for="config_info" position="bottom" animation-delay=0>Click for Trigger Configuration details</paper-tooltip>
          </div>
        </div>
      </section>

      <big-status-icon run-data=[[runData]] subsystem-data=[[subsystemData.subsystems]]></big-status-icon>

      <section right banner second-row>
        <div horizontal right>
          <div flexitem>
            <p title>Status</p>
            <p lowercase>[[runData.triggerState]]</p>
          </div>
          <div flexitem hide$=[[!_running]]>
            <p title>Run</p>
            <p>#[[runData.runNumber]]</p>
          </div>
          <div flexitem hide$=[[!_running]]>
            <p title>Start time</p>
            <span>for <relative-time time=[[runData.startTime]] input-format="M/D/YY h:mm:ss A" input-timezone=UTC output-format=fromNowBrief></relative-time></span>
          </div>
          <div flexitem hide$=[[!_running]]>
            <p title>LS</p>
            <p>[[runData.trgMoni.LUMI_SECTION]]</p>
          </div>
          <div show-hand flexitem on-click="gotoRates" hide$=[[!_running]]>
            <p title>Rate</p>
            <p show-hand id="rate_info" align="right" threshold$=[[_passThreshold(runData.trgMoni.TOTAL_UGT_RATE.ALGO_RATE)]]>[[_displayRate(runData.trgMoni.TOTAL_UGT_RATE.ALGO_RATE)]] Hz</p>
            <paper-tooltip for="rate_info" position="bottom" animation-delay=0>Click for Rate details</paper-tooltip>
          </div>
        </div>
      </section>

      <!-- <paper-progress indeterminate bottom-item></paper-progress> -->
    </app-toolbar>

    <iron-pages selected="[[_selectedPage]]" attr-for-selected="name" fallback-selection="home" role="main">
      <div name="home">
        <l1-home
          url-data={{urlData}}
          url-data-tail={{urlDataTail}}
          route={{route}}
          run-data="[[runData]]"
          subsystem-data="[[subsystemData]]"></l1-home>
      </div>
      <div name="rates">
        <trigger-rates
          route={{route}}
          run-data="[[runData]]"
          subsystem-data="[[subsystemData]]"></trigger-rates>
      </div>
    </iron-pages>

    <app-drawer id=drawer swipe-open persistent$="[[!stickyMenu]]" opened="{{stickyMenu}}" >
      <paper-icon-button icon="editor:attach-file" on-click=toggleDrawer></paper-icon-button>
      <l1page-drawer-links></l1page-drawer-links>
    </app-drawer>

    <paper-dialog small with-backdrop
                  opened="[[_widgetActive('configuration', urlData)]]"
                  on-iron-overlay-closed=_closeActiveWidget>
      <subsystem-keys run-data=[[runData]]></subsystem-keys>
      <div class="buttons">
        <paper-button primary dialog-confirm autofocus>Close</paper-button>
      </div>
    </paper-dialog>

    <paper-dialog with-backdrop
                  opened="[[_widgetActive('process-controller', urlData)]]"
                  on-iron-overlay-closed=_closeActiveWidget>
      <process-controller subsystem-data=[[subsystemData.subsystems]] trigger-state=[[runData.triggerState]]></process-controller>
      <div class="buttons">
        <paper-button primary dialog-confirm autofocus>Close</paper-button>
      </div>
    </paper-dialog>

<!--     <paper-dialog big with-backdrop
                  opened="[[_widgetActive('subsystem', urlData)]]"
                  on-iron-overlay-closed=_closeActiveWidget>
      <subsystem-details subsystem-data=[[subsystemData.subsystems]] included-subsystems=[[runData.includedSubsystems]] route={{urlDataTail}}></subsystem-details>
      <div class="buttons">
        <paper-button primary dialog-confirm autofocus>Close</paper-button>
      </div>
    </paper-dialog> -->

<!--     <paper-dialog big with-backdrop
                  opened="[[_widgetActive('rates', urlData)]]"
                  on-iron-overlay-closed=_closeActiveWidget>
      <trigger-rates included-subsystems=[[runData.includedSubsystems]] route={{urlDataTail}}></trigger-rates>
      <div class="buttons">
        <paper-button primary dialog-confirm autofocus>Close</paper-button>
      </div>
    </paper-dialog> -->

    <paper-dialog with-backdrop
                  opened="[[_widgetActive('call', urlData)]]"
                  on-iron-overlay-closed=_closeActiveWidget>
      <h1>L1 Doc: <a href="tel:16-1958">16-1958</a></h1>
      <h1>HLT Doc: <a href="tel:16-5575">16-5575</a></h1>
      <p>Full list on the <a target="_blank" href="https://twiki.cern.ch/twiki/bin/viewauth/CMS/OnlineWBTriggerContacts">TWiki page</a></p>
      <div class="buttons">
        <paper-button primary dialog-confirm autofocus>Close</paper-button>
      </div>
    </paper-dialog>

    <toast-manager></toast-manager>

  </template>
</dom-module>

<script src="l1-page.js?__inline=true"></script>
